;ESTE PROGRAMA FOI COMPILADO NO MAKENSISW 2.0
;OBJETIVO:
	; INSTALAR O LIBREOFFICE.ORG 3.5.5 + HELP NAS ESTAES DA REDE WINDOWS VIA LOGIN SCRIPT
;CARACTERSTICAS DO INSTALADOR: INSTALAO FORADA DESASSISTIDA; FAZ NOVA TENTATIVA DE INSTALAO A CADA 10 MINUTOS
;AUTOR: 07/11/2008 - primeira verso, por KRAUCER FERNANDES MAZUCO (07/11/2008) - GETEC 35
;       14/09/2012 - readaptado para o LibreOffice, por KRAUCER FERNANDES MAZUCO - GECIN I


; FALTA: ATUALIZAR O LIBRE-PERSONAL E COMPATIBILIZAR O ARTIGO

Name "Instalador do LibreOffice.org 3.5.5 Rede Man/Intrabb."
OutFile "instalar.exe"
!include "FileFunc.nsh"
!insertmacro DriveSpace
!include "LogicLib.nsh"
!insertmacro GetTime
!include "WinMessages.nsh"
RequestExecutionLevel user ;exigido pelo UAC do Windows Vista
ShowInstDetails Nevershow
Var VAL		;valor sequencial da instalao
Var LIM		;valor limite de instalaes simultneas
Var TEN		;nmero de tentativas
Var ATU
Var ATT
Var dat1
Var dat2
Var dat3
Var dat4
Var dat5
Var dat6
Var dat7
Var hor1
Var hor2
Var min1
Var min2
Var intermin
Var USERNAME
Var SISOP

Function .onInit
		SetSilent Silent
		;O CONTROLE DA EXISTNCIA OU NO DO LIBREOFFICE NO EST MAIS NO LOGIN SCRIPT. POR ESSE MOTIVO, IREI VERIFICAR AGORA SUA
		;EXISTNCIA. CASO ESTEJA INSTALADO, NO IREI EXECUTAR O INSTALADOR
		IfFileExists "$PROGRAMFILES\LibreOffice 3.5\program\soffice.exe" 0 +2
			Quit
			
		;PROCEDIMENTO VERIFICA SE O ARQUIVO CONTADOR FICOU MAIS DE 30 MINUTOS SEM ALTERAES
		;SE FICOU, PROVAVELMENTE O MESMO TRAVOU O VALOR DO CONTADOR NO VALOR MXIMO, IMPEDINDO NOVAS INSTALAES
		;NESTE CASO, O SISTEMA IR RETORNAR O VALOR DO CONTADOR AO VALOR INICIAL DE ZERO (0)
		${GetTime} "P:\LibreOffice\contador.txt" "m" $dat1 $dat2 $dat3 $dat4 $dat5 $dat6 $dat7
		; $dat1="01"      day
		; $dat2="04"      month
		; $dat3="2005"    year
		; $dat4="Friday"  day of week name
		; $dat5="16"      hour
		; $dat6="05"      minute
		; $dat7="50"      seconds
		IntOp $hor1 $dat5 * 60
		IntOp $min1 $dat6 + $hor1
		${GetTime} "" "L" $0 $1 $2 $3 $4 $5 $6
		; $0="01"      day
		; $1="04"      month
		; $2="2005"    year
		; $3="Friday"  day of week name
		; $4="16"      hour
		; $5="05"      minute
		; $6="50"      seconds
		IntOp $hor2 $4 * 60
		IntOp $min2 $5 + $hor2
		IntOp $intermin $min2 - $min1
			
		${If} $0 != $dat1
			CopyFiles H:\LibreOffice\contador.txt "P:\LibreOffice\contador.txt"
		${ElseIf} $0 = $dat1
			${If} $intermin > '30'
				CopyFiles H:\LibreOffice\contador.txt "P:\LibreOffice\contador.txt"
			${EndIf}
		${EndIf}
		
		;VERIFICA SE EXISTE O ARQUIVO contador.txt. SE NO EXISTIR, ELE  CRIADO A PARTIR DE UMA CPIA DO DRIVE H:
		ClearErrors
		${DriveSpace} "p:\LibreOffice\contador.txt" "/D=F /S=M" $R2
		IfErrors 0 +2
			CopyFiles H:\LibreOffice\contador.txt "p:\LibreOffice\contador.txt"
		
		;ABRE O ARQUIVO contador.txt PARA LER O NMERO DE INSTALAES SIMULTNEAS ONLINE
Nova_tentativa:	ClearErrors
		IntOP $TEN $TEN + 1
		FileOpen $0 p:\LibreOffice\contador.txt a
		IfErrors 0 +2
			Goto Wait_Open
		FileRead $0 $1
		IntOp $VAL $1 + 1
		FileClose $0
		
		;ABRE O ARQUIVO LIMITE.TXT PARA LER A VARIVEL QUE CONTM O NMERO LIMITE DE INSTALAES SIMULTNEAS
		ClearErrors
		FileOpen $0 H:\LibreOffice\limite.txt r
            FileRead $0 $LIM
		FileClose $0

		;SE O NMERO DE INSTALAES SIMULTNEAS FOR ATINGIDO, FINALIZA O PROGRAMA
		${If} $VAL > $LIM
		  	; FAREI NOVA TENTATIVA DE INSTALAO APS 10 MINUTOS
			sleep 6000
			call .onInit
		${EndIf}	

		;INCREMENTA O CONTADOR DE INSTALAES SIMULTNEAS
Reabre:	ClearErrors
		IntOP $ATU $ATU + 1
		FileOpen $0 p:\LibreOffice\contador.txt a
		IfErrors 0 +2
			Goto Wait_atual		
		FileWrite $0 $VAL
            FileClose $0
		Goto +16

Wait_Open:	${If} $TEN >= '10'
			Quit
		${ElseIf} $TEN < '10'
			Sleep 2000
			Goto Nova_tentativa
		${EndIf}		
		Quit

Wait_atual:	${If} $ATU >= '10'
			Quit
		${Elseif} $ATU < '10'
			Sleep 500
			Goto Reabre
		${Endif}
		Quit
FunctionEnd

Section "Incio"
	;ROTINA VERIFICA SE O ESPAO EM DISCO  SUFICIENTE PARA A INSTALAO
	${DriveSpace} "C:\" "/D=F /S=M" $R0
	${If} $R0 >= '800'

		;IREI LER O SISTEMA OPERACIONAL DEVIDO A ALGUMAS ESPECIFICIDADES ENTRE XP E VISTA
		ReadRegStr $SISOP HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion" ProductName
		
		;BUSCO O NOME DO USURIO LOGADO NO MOMENTO DA INSTALAO
		UserInfo::GetName
		Pop $USERNAME
		
		;POR NO CONSEGUIR TRATAR CORRETAMENTE A CONSTANTE $LOCALAPPDATA, IREI VERIFIC-LA CONFORME O SISTEMA OPERACIONAL
		ReadRegStr $SISOP HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion" ProductName
				
		;EXECUTA A INSTALAO DO LIBREOFFICE.ORG EM MODO QUIET
		MessageBox MB_OK|MB_ICONEXCLAMATION "O LibreOffice de sua estao ser atualizado para a verso 3.5.5 e as verses anteriore sero removidas. Favor no utilizar o aplicativo LibreOffice at que o processo seja concludo. Voc ser notificado sobre o trmino do mesmo em no mximo 15 minutos. Clique em OK para continuar."
		DetailPrint "Instalando o LibreOffice 3.5..5..aguarde!!!"
		
		;S IREI MOSTRAR A MENSAGEM ABAIXO SE O SISTEMA OPERACIONAL FOR WINDOWS VISTA
		StrCmp $SISOP "Windows Vista (TM) Business" 0 +2
		MessageBox MB_OK|MB_ICONEXCLAMATION "ATENO USURIOS DO WINDOWS VISTA: Na prxima tela, clique na opo 'PERMITIR' para que a instalao possa prosseguir."
		
		;S IREI MOSTRAR A MENSAGEM ABAIXO SE O SISTEMA OPERACIONAL FOR WINDOWS 7
		StrCmp $SISOP "Windows 7 Professional" 0 +2
		MessageBox MB_OK|MB_ICONEXCLAMATION "ATENO USURIOS DO WINDOWS 7: Na prxima tela, clique na opo 'PERMITIR' para que a instalao possa prosseguir."
		
		ExecWait "msiexec /passive /norestart /qn /i H:\LibreOffice\LibO_3.5.5_Win_x86_install_multi.msi ISCHECKFORPRODUCTUPDATES=0"
		ExecWait "msiexec /passive /norestart /qn /i H:\LibreOffice\LibO_3.5.5_Win_x86_helppack_pt-BR.msi"

		;APLICA AS PERSONALIZAES/INSTALAO DE EXTENSES DO LIBREOFFICE PARA O USURIO ATUAL
		ExecWait "H:\LibreOffice\personal\libre-personal.exe"
		
		;L O ARQUIVO contador.txt E DECREMENTA O CONTADOR DE INSTALAES SIMULTNEAS NO FINAL DA INSTALAO
		DetailPrint "Abrindo arquivo de contagem..."
		ClearErrors
		FileOpen $0 p:\LibreOffice\contador.txt a
		FileRead $0 $1
		IntOp $VAL $1 - 1
		FileClose $0

		;ATUALIZA O VALOR DO CONTADOR DE INSTALAES SIMULTNEAS
		DetailPrint "Decrementando nmero de instalaes simultneas..."
		ClearErrors
		FileOpen $0 p:\LibreOffice\contador.txt a
		FileWrite $0 $VAL
            FileClose $0
		${If} $VAL < 0
			CopyFiles H:\LibreOffice\contador.txt "p:\Libreoffice\contador.txt"
		${Endif}
		${If} $VAL > $LIM
			CopyFiles H:\LibreOffice\contador.txt "p:\LibreOffice\contador.txt"
		${Endif}
		IfFileExists "$PROGRAMFILES\LibreOffice 3.5\program\soffice.exe" +3 0
			MessageBox MB_OK|MB_ICONEXCLAMATION "A instalao do LibreOffice 3.5.5 foi cancelada. Ser realizada nova tentativa no prximo logon."
			Quit
		MessageBox MB_OK|MB_ICONEXCLAMATION "O LibreOffice 3.5.5 e as seguintes extenses foram instaladas com sucesso: modelos de etiquetas Pimaco, Dicionrio de Sinnimos e BB Menu."
		Quit
		
	${ElseIf} $R0 < '400'
		;CANCELA O PROCESSO DE INSTALAO DEVIDO AO ESPAO INSUFICIENTE NO DISCO
		;DECREMENTA O VALOR DO CONTADOR DE INSTALAES SIMULTNEAS
		DetailPrint "Decrementando nmero de instalaes simultneas..."
Re_open:	IntOP $ATT $ATT + 1
		ClearErrors
		FileOpen $0 p:\LibreOffice\contador.txt a
		IfErrors 0 +2
			Goto Wait_att
		FileWrite $0 $1
        FileClose $0
		MessageBox MB_OK|MB_ICONEXCLAMATION "A instalao automtica do LibreOffice 3.5.5 foi cancelada.  necessrio um espao mnimo de 800 MegaBytes livres no disco rgido. Clique no boto OK para finalizar."
	    Quit
    ${EndIf}

Wait_att:	${If} $ATT >= '10'
			Quit
		${Elseif} $ATT < '10'
			Sleep 500
			Goto Re_open
		${Endif}
		Quit
SectionEnd