;ESTE PROGRAMA FOI COMPILADO NO MAKENSISW 2.0
;OBJETIVOS:
	;1. INSTALAR AS SEGUINTES EXTENSES QUE FICARO DISPONVEIS PARA O USURIO QUE LOGOU NA ESTAO
		;- VERIFICADOR ORTOGRFICO
		;- MODELOS DE DOCUMENTOS BB
		;- DICIONRIO DE SINNIMOS
		;- BB MENU
		;- BB FORMULRIOS
		;- ETIQUETAS PIMACO
		;- DESENHOS PIMACO
		;- MODELOS PIMACO
;CARACTERSTICAS DO INSTALADOR: INSTALAO FORADA DESASSISTIDA
;COMPATVEL COM WINDOWS XP, VISTA E 7
;VERSO ESPECFICA PARA O DRIVE H
;DATA DE CRIAO: 25/07/2012
;AUTORES: KRAUCER FERNANDES MAZUCO <kraucer@bb.com.br>
;		  KLAUS ASSMANN <klaus.assmann@bb.com.br>

Name "Personalizador do LibreOffice - Rede MAN/INTRABB"
OutFile "libre_personal.exe"
!include "FileFunc.nsh"
!include "LogicLib.nsh"
!include "WinMessages.nsh"
RequestExecutionLevel user ;apenas para o Windows Vista + UAC
ShowInstDetails Nevershow
Var LOCALDATA
Var USERNAME
Var SISOP

Function .onInit
	SetSilent Silent
FunctionEnd

Section "Incio"
	;IREI LER O SISTEMA OPERACIONAL DEVIDO A ALGUMAS ESPECIFICIDADES ENTRE XP E VISTA
	ReadRegStr $SISOP HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion" ProductName
		
	;BUSCO O NOME DO USURIO LOGADO NO MOMENTO DA INSTALAO
	UserInfo::GetName
	Pop $USERNAME
	
	;POR NO CONSEGUIR TRATAR CORRETAMENTE A CONSTANTE $LOCALAPPDATA, IREI VERIFIC-LA CONFORME O SISTEMA OPERACIONAL
	ReadRegStr $SISOP HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion" ProductName
	StrCpy $LOCALDATA "C:\Documents and Settings\$USERNAME\dados de aplicativos"
	${If} $SISOP == 'Microsoft Windows XP'
		StrCpy $LOCALDATA "C:\Documents and Settings\$USERNAME\dados de aplicativos"
	${ElseIf} $SISOP == 'Windows Vista (TM) Business'
		StrCpy $LOCALDATA "C:\Users\$USERNAME\AppData\Roaming"
	${ElseIf} $SISOP == 'Windows 7 Professional'
		StrCpy $LOCALDATA "C:\Users\$USERNAME\AppData\Roaming"
	${EndIf}
		
	;O CONTROLE DA EXISTNCIA OU NO DAS PERSONALIZAES DO LIBREOFFICE NO EST NO LOGIN SCRIPT. POR ESSE MOTIVO, IREI VERIFICAR AGORA SUA
	;EXISTNCIA. CASO AS PERSONALIZAES J EXISTIREM,  NO IREI EXECUTAR.		
    IfFileExists "$PROGRAMFILES\LibreOffice 3.5\program\soffice.exe" 0 +2
		IfFileExists "$LOCALDATA\LibreOffice\3\user\flag_personal.txt" 0 +2
	Quit
			
	;INSTALANDO A EXTENSO DO MODELO DE DOCUMENTOS
	ExecWait "$PROGRAMFILES\LibreOffice 3.5\program\unopkg.exe add H:\LibreOffice\Modelos_BrOffice-BB-v01.oxt"			

	;INSTALANDO A EXTENSO PIMACO (ETIQUETAS, GABARITOS E MODELOS)
	ExecWait "$PROGRAMFILES\LibreOffice 3.5\program\unopkg.exe add H:\LibreOffice\pimaco-labels.oxt"
	ExecWait "$PROGRAMFILES\LibreOffice 3.5\program\unopkg.exe add H:\LibreOffice\pimaco-drawings.oxt"
	ExecWait "$PROGRAMFILES\LibreOffice 3.5\program\unopkg.exe add H:\LibreOffice\pimaco-templates.oxt"
		
	;INSTALANDO A EXTENSO DICIONRIO DE SINNIMOS
	ExecWait "$PROGRAMFILES\LibreOffice 3.5\program\unopkg.exe add H:\LibreOffice\DicSin-BR.oxt"
				
	;INSTALANDO A EXTENSO BB MENU
	ExecWait "$PROGRAMFILES\LibreOffice 3.5\program\unopkg.exe add H:\LibreOffice\BB_menu.oxt"
		
	;INSTALANDO A EXTENSO BB FORMULRIOS
	ExecWait "$PROGRAMFILES\LibreOffice 3.5\program\unopkg.exe add H:\LibreOffice\BB_formularios.oxt"
		
	;INSTALANDO DICIONRIOS TEMTICOS DE INFORMTICA E JURDICO APENAS PARA O USURIO QUE INSTALOU O LIBREOFFICE POIS NO
	;CONSIGO ESCREVER NO C:\PROGRAM FILES DO VISTA DEVIDO AO UAC
	IfFileExists "$LOCALDATA\LibreOffice\3\user\wordbook\DicInfo.dic" +9 0
		SetOverwrite on
		SetOutPath "$LOCALDATA\LibreOffice\3\user\wordbook"
		File "H:\SoftwareLivre\LibreOffice_v355\Personal\dict\DicInfo.dic"
		File "H:\SoftwareLivre\LibreOffice_v355\Personal\dict\DicInfo2.dic"
		File "H:\SoftwareLivre\LibreOffice_v355\Personal\dict\DicInfo3.dic"
		File "H:\SoftwareLivre\LibreOffice_v355\Personal\dict\DicJuridico.dic"
		File "H:\SoftwareLivre\LibreOffice_v355\Personal\dict\DicEletro.dic"
		File "H:\SoftwareLivre\LibreOffice_v355\Personal\dict\DicEconomia.dic"
		
	;FAREI UMA CPIA DO ARQUIVO flag_personal.txt SINALIZANDO QUE A PERSONALIZAO DO LIBREOFFICE FOI APLICADA COM SUCESSO, EVITANDO
	;DESTA FORMA UMA NOVA APLICAO DESNECESSRIA
	SetOverwrite on
	SetOutPath "$LOCALDATA\LibreOffice\3\user"
	File "H:\SoftwareLivre\LibreOffice_v355\Flags\flag_personal.txt"
	Quit
SectionEnd